<?php

namespace Teknisa\SM\Service;

use Teknisa\Libs\Util\Environment;
use Teknisa\SM\Factory\Sm00001000EnderecoPropostaFactory;

class Sm00001000EnderecoPropostaService {
    
    protected $enderecoPropostaFactory;
    
    public function __construct(Sm00001000EnderecoPropostaFactory $enderecoPropostaFactory) {
        $this->enderecoPropostaFactory = $enderecoPropostaFactory;
    }
    
    /**
     * Verifica se já existe um registro com o mesmo tipo de endereço que se está tentando salvar.
     * 
     * @param integer $nrseqorcamento
     * @param integer $nrenderecoorca
     * @param string $cdtipoendereco
     * @param integer $nrorg
     * 
     * @return mixed[]
     */
    public function verificarSeExisteTipoEndereco($nrseqorcamento, $nrenderecoorca, $cdtipoendereco, $nrorg) {
        $params = array(
            "NRSEQORCAMENTO" => $nrseqorcamento,
            "NRENDERECOORCA" => $nrenderecoorca,
            "CDTIPOENDERECO" => $cdtipoendereco,
            "NRORG"          => $nrorg
        );
        
        $dataset = $this->enderecoPropostaFactory->verificarSeExisteTipoEndereco($params);
        return ((int)$dataset[0]["EXISTE"] > 0);
    }
}

?>