/* Tabela INSCRMUNICIP: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela INSCRMUNICIP */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela INSCRMUNICIP utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_INSCRMUNICIP
AFTER DELETE OR INSERT OR UPDATE
ON INSCRMUNICIP FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_CDFILLOGOPER VARCHAR2(4);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   V_CDFILLOGOPER := '';

   IF DELETING THEN

      IF :OLD.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || 'CDEmpresa=' || :OLD.CDEMPRESA;
      END IF;

      IF :OLD.CDINSCMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' Cod=' || :OLD.CDINSCMUNI;
      END IF;

      IF :OLD.NMREPRINSMUN IS NOT NULL THEN
         V_DESC := V_DESC || ' ReprLegal=' || :OLD.NMREPRINSMUN;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDEMPRESA||:OLD.CDINSCMUNI;
      V_CDFILLOGOPER := :OLD.CDFILIAL;
   ELSE
      IF UPDATING THEN

         IF (:OLD.CDEMPRESA    <> :NEW.CDEMPRESA)    OR
            (:OLD.CDINSCMUNI   <> :NEW.CDINSCMUNI)   OR
            (NVL(:OLD.NMREPRINSMUN,'!') <> NVL(:NEW.NMREPRINSMUN,'!')) THEN
            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDEMPRESA||:OLD.CDINSCMUNI;
            V_CDFILLOGOPER := :OLD.CDFILIAL;
         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDEMPRESA||:NEW.CDINSCMUNI;
         V_CDFILLOGOPER := :NEW.CDFILIAL;
      END IF;

      IF :NEW.CDEMPRESA IS NOT NULL THEN
         V_DESC := V_DESC || ' Empresa=' || :NEW.CDEMPRESA;
      END IF;

      IF :NEW.CDINSCMUNI IS NOT NULL THEN
         V_DESC := V_DESC || ' Cod=' || :NEW.CDINSCMUNI;
      END IF;

      IF (NVL(:OLD.NMREPRINSMUN,'!') <> NVL(:NEW.NMREPRINSMUN,'!')) THEN
         V_DESC := V_DESC || ' ReprLegal=' || :NEW.NMREPRINSMUN;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                CDFILLOGOPER, DSRDMUSUOPER, DSENDUSUOPER,
                DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('INSCRMUNICIP',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,  V_CDFILLOGOPER,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST,
                V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_INSCRMUNICIP','4.09.060'); END;
/

