/* Sistemas Integrados TEKNISA
   Nome: 0004_FASSTP_FATURA_CUSTUMIZACAO.SQL
   Descrio:
   Procedimento para Faturamento de Customizao.
   18/08/2010 - O procedimento para Faturamento de Customizao
                  foi alterado para gerar uma apurao por parcela.
*/

CREATE OR REPLACE 
PROCEDURE FATURA_CUSTOMIZACAO
   (P_CDCLIENTE IN VARCHAR2,
    P_NRSOLISERV IN VARCHAR2,
    P_CDOPERAPUR IN VARCHAR2,
    P_NAC IN VARCHAR2,
    P_MES IN DATE)
AS
   V_ANTE_CDFILIAL SOLISERV.CDFILIAL%TYPE;
   V_ANTE_NRSOLISERV SOLISERV.NRSOLISERV%TYPE;
   V_PRXAPURACAO VARCHAR2(20);
   V_DSBOLETCLIE VARCHAR2(2000);
   V_DSFATURCLIE VARCHAR2(2000);
   V_CDEMPRESA VARCHAR2(2);
   V_CDFILIAL VARCHAR2(4);
   V_CDPRODUTO VARCHAR2(10);
   V_PRODNAC VARCHAR2(10);
   V_PRODINT VARCHAR2(10);
   V_DATA DATE;
   V_MES DATE;
   V_DESCBOLETO VARCHAR2(100);
   V_DSNOTACLIE VARCHAR2(100);
BEGIN
   V_ANTE_CDFILIAL := 'X';
   V_ANTE_NRSOLISERV := 'X';
   V_MES := P_MES;
   SELECT TRUNC(SYSDATE)
     INTO V_DATA
     FROM DUAL;
   SELECT MAX(CDPROFATSOLI), MAX(CDPROFATINTSOLI)
     INTO V_PRODNAC, V_PRODINT
     FROM PAR_GERAL_FAS;
   -- ######################################################################
   -- #### Apurao das solicitaes COM registro na PARCSOLISERV. 
   -- ######################################################################
   FOR CUR_SOLI IN (SELECT S.CDFILIAL, S.NRSOLISERV, P.VRPARCSOLI, P.NRPARCSOLI,
                           S.CDCLIENTE, E.CDPAIS,
                           SUM(1) OVER (PARTITION BY S.CDFILIAL, S.NRSOLISERV) TOTAL_PARCELA
                      FROM SOLISERV S, ENDECLIE E, PARCSOLISERV P
                     WHERE S.CDASSUNTO = '00021'
                       AND S.NRAPURFATFAS IS NULL /* ESTE TESTE FOI MANTIDO, POIS
                                                     EXISTEM SOLICITAES QUE J FORAM
                                                     FATURADAS NA FORMA ANTIGA, OU SEJA,
                                                     UMA APURAO POR SOLICITAO COM
                                                     O VALOR TOTAL */
                       AND ((INSTR(P_CDCLIENTE, '_' || S.CDCLIENTE || '_') > 0) OR (P_CDCLIENTE = 'C'))
                       AND ((INSTR(P_NRSOLISERV, '_' || S.NRSOLISERV || '_') > 0) OR (P_NRSOLISERV = 'S'))
                       AND EXISTS (SELECT *
                                     FROM LOGFASETRAM L
                                    WHERE L.CDFILIAL = S.CDFILIAL
                                      AND L.NRSOLISERV = S.NRSOLISERV
                                      AND L.CDFASETRAM = '205') /* FASE DE LIBERAO PARA O CLIENTE */
                       AND P.CDFILIAL = S.CDFILIAL
                       AND P.NRSOLISERV = S.NRSOLISERV
                       AND P.VRPARCSOLI > 0
                       AND P.NRAPURFATFAS IS NULL /* SOMENTE PARCELAS NO APURADAS */
                       AND E.CDCLIENTE = S.CDCLIENTE
                       AND E.IDTPENDECLIE = 'P'
                       AND ((E.CDPAIS <> '0055' AND (INSTR(P_NAC, '_I_') > 0)) OR (E.CDPAIS = '0055' AND (INSTR(P_NAC, '_N_') > 0)))
                     ORDER BY S.CDFILIAL, S.NRSOLISERV, P.NRPARCSOLI) LOOP

      V_DESCBOLETO := '';
      V_DSNOTACLIE := '';

      /* VERIFICA A SOLICITAO E JOGA A DATA DA APURAO PRO CAMPO V_MES */
      IF V_ANTE_CDFILIAL <> CUR_SOLI.CDFILIAL OR
         V_ANTE_NRSOLISERV <> CUR_SOLI.NRSOLISERV THEN
         V_ANTE_CDFILIAL := CUR_SOLI.CDFILIAL;
         V_ANTE_NRSOLISERV := CUR_SOLI.NRSOLISERV;
         V_MES := P_MES;
      END IF;
      BEGIN
         SELECT P.DSBOLETCLIE, P.DSFATURCLIE, P.CDEMPRESA, F.CDFILIAL
           INTO V_DSBOLETCLIE, V_DSFATURCLIE, V_CDEMPRESA, V_CDFILIAL
           FROM PARCLIEFAS P, FILIAL F
          WHERE P.IDTPFATUCLIE = '1'
            AND P.CDCLIENTE = CUR_SOLI.CDCLIENTE
            AND P.CDEMPRESA = F.CDEMPRESA
            AND ROWNUM = 1;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            NULL;
      END;

      /*A EMPRESA 12 POSSUI 3 FILIAIS, A PEDIDO DA POLIANA SER GERADO O FATURAMENTO SEMPRE PARA A FILIAL 9990*/ 
      IF V_CDEMPRESA = '12' THEN
         V_CDFILIAL := '9990';
      END IF;

      /* conforme acordado com a Poliana,
        a descrio do boleto e da nota sero fixas,
        para que o incluir um novo cliente nao seja necessario alterar a descrio*/
      /*V_DESCBOLETO := V_DSBOLETCLIE;*/
      V_DESCBOLETO := 'Customizao ref solicitao XXXXXX. Parcela XX/XX.';
      V_DESCBOLETO := REPLACE(V_DESCBOLETO, 'XXXXXX', CUR_SOLI.NRSOLISERV);
      IF LPAD(CUR_SOLI.NRPARCSOLI,2,'0') = '01' AND LPAD(CUR_SOLI.TOTAL_PARCELA,2,'0') = '01' THEN
         V_DESCBOLETO := REPLACE(V_DESCBOLETO, 'XX/XX', 'nica');
      ELSE
         V_DESCBOLETO := REPLACE(V_DESCBOLETO, 'XX/XX', LPAD(CUR_SOLI.NRPARCSOLI,2,'0')||'/'||LPAD(CUR_SOLI.TOTAL_PARCELA,2,'0'));
      END IF;

      /*V_DSNOTACLIE := V_DSFATURCLIE;*/
      V_DSNOTACLIE := V_DESCBOLETO;

      NOVO_CODIGO('APURFATUFAS', V_PRXAPURACAO);
      IF CUR_SOLI.CDPAIS = '0055' THEN
         V_CDPRODUTO := V_PRODNAC;
      ELSE
         V_CDPRODUTO := V_PRODINT;
      END IF;
      INSERT INTO APURFATUFAS
         (CDFILIAL, CDCLIENTE, NRAPURFATFAS,
          DTAPURFATFAS, VRTOTAFATFAS, DSEMISSPRONF,
          CDOPERAPUR, CDEMPRESA, CDPRODUTO,
          IDAPURFATFAS, IDSTAPFATFAS, IDCOMIFATFAS,
          DSBOLEFATFAS, DTMESAPURFAS, CDGRUPONFAPUR, CDFILISOLISERV, NRSOLISERV)
      VALUES
         (V_CDFILIAL, CUR_SOLI.CDCLIENTE, SUBSTR(V_PRXAPURACAO, 11, 10),
          V_DATA, CUR_SOLI.VRPARCSOLI, V_DSNOTACLIE,
          P_CDOPERAPUR, V_CDEMPRESA, V_CDPRODUTO,
          '3', 'P', 'N',
          V_DESCBOLETO, V_MES, '01', CUR_SOLI.CDFILIAL, CUR_SOLI.NRSOLISERV);
         UPDATE PARCSOLISERV
            SET NRAPURFATFAS = SUBSTR(V_PRXAPURACAO, 11, 10)
          WHERE NRAPURFATFAS IS NULL
            AND CDFILIAL = CUR_SOLI.CDFILIAL
            AND NRSOLISERV = CUR_SOLI.NRSOLISERV
            AND NRPARCSOLI = CUR_SOLI.NRPARCSOLI;
      /* GERA UMA APURAO POR PARCELA E JOGA A PARCELA PARA O PROXIMO MS */
      SELECT ADD_MONTHS(V_MES, 1)
        INTO V_MES
        FROM DUAL;
   END LOOP;
   COMMIT;
END;
/ 

-- VERSAO --
BEGIN ATUVEROBJ('FATURA_CUSTOMIZACAO','5.05.022'); END;
/