/* Sistemas Integrados TECNISA

Nome: 00NJ_CDPTRGS_DTULTATU_TPROCFABRICA.SQL

Descrio:

Atualiza a data de ultima atualizao da tabela TPROCFABRICA

Criao:
07/05/2007 Ronald Reis
*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TPROCFABRICA' and
            type = 'TR'                      and
            u.uid = o.uid                    and
            u.name = USER)
  DROP TRIGGER DTULTATU_TPROCFABRICA
  GO

CREATE TRIGGER DTULTATU_TPROCFABRICA
ON TPROCFABRICA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TPROCFABRICA', '', 'CDPROCFABRIC=' + CDPROCFABRIC+';' , GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TPROCFABRICA
      SET DTULTATUTFAB = GETDATE()
      FROM INSERTED
      WHERE ISNULL(TPROCFABRICA.CDPROCFABRIC,0) = ISNULL(INSERTED.CDPROCFABRIC,0)
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TPROCFABRICA','4.11.134';
GO
